#include <kdialog.h>
#include <klocale.h>

#ifndef UI_CODEGENERATIONWIZARDBASE_H
#define UI_CODEGENERATIONWIZARDBASE_H

#include <qvariant.h>

class UMLClassifier;

#include <Qt3Support/Q3Frame>
#include <Qt3Support/Q3GroupBox>
#include <Qt3Support/Q3Header>
#include <Qt3Support/Q3ListView>
#include <Qt3Support/Q3Wizard>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QGridLayout>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>
#include <QtGui/QWidget>

class Ui_CodeGenerationWizardBase
{
public:
    QWidget *select;
    QVBoxLayout *vboxLayout;
    QLabel *TextLabel1;
    Q3Frame *Frame4;
    QGridLayout *gridLayout;
    QPushButton *m_addButton;
    QSpacerItem *spacerItem;
    Q3ListView *m_selectedList;
    QPushButton *m_removeButton;
    QSpacerItem *spacerItem1;
    Q3ListView *m_availableList;
    QSpacerItem *spacerItem2;
    QWidget *status;
    QVBoxLayout *vboxLayout1;
    QLabel *m_label;
    Q3GroupBox *GroupBox2;
    QVBoxLayout *vboxLayout2;
    Q3ListView *m_statusList;

    void setupUi(Q3Wizard *CodeGenerationWizardBase)
    {
    CodeGenerationWizardBase->setObjectName(QString::fromUtf8("CodeGenerationWizardBase"));
    select = new QWidget(CodeGenerationWizardBase);
    select->setObjectName(QString::fromUtf8("select"));
    vboxLayout = new QVBoxLayout(select);
    vboxLayout->setSpacing(10);
    vboxLayout->setMargin(0);
    vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
    TextLabel1 = new QLabel(select);
    TextLabel1->setObjectName(QString::fromUtf8("TextLabel1"));
    TextLabel1->setWordWrap(false);

    vboxLayout->addWidget(TextLabel1);

    Frame4 = new Q3Frame(select);
    Frame4->setObjectName(QString::fromUtf8("Frame4"));
    Frame4->setFrameShape(Q3Frame::Box);
    Frame4->setFrameShadow(Q3Frame::Plain);
    Frame4->setMargin(10);
    gridLayout = new QGridLayout(Frame4);
    gridLayout->setSpacing(10);
    gridLayout->setMargin(20);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    m_addButton = new QPushButton(Frame4);
    m_addButton->setObjectName(QString::fromUtf8("m_addButton"));
    m_addButton->setIcon(icon(image0_ID));

    gridLayout->addWidget(m_addButton, 1, 1, 1, 1);

    spacerItem = new QSpacerItem(20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding);

    gridLayout->addItem(spacerItem, 0, 1, 1, 1);

    m_selectedList = new Q3ListView(Frame4);
    m_selectedList->addColumn(tr2i18n("Classes Selected", 0));
    m_selectedList->header()->setClickEnabled(true, m_selectedList->header()->count() - 1);
    m_selectedList->setObjectName(QString::fromUtf8("m_selectedList"));
    QSizePolicy sizePolicy(static_cast<QSizePolicy::Policy>(7), static_cast<QSizePolicy::Policy>(7));
    sizePolicy.setHorizontalStretch(1);
    sizePolicy.setVerticalStretch(0);
    sizePolicy.setHeightForWidth(m_selectedList->sizePolicy().hasHeightForWidth());
    m_selectedList->setSizePolicy(sizePolicy);
    m_selectedList->setSelectionMode(Q3ListView::Extended);

    gridLayout->addWidget(m_selectedList, 0, 2, 5, 1);

    m_removeButton = new QPushButton(Frame4);
    m_removeButton->setObjectName(QString::fromUtf8("m_removeButton"));
    m_removeButton->setIcon(icon(image1_ID));

    gridLayout->addWidget(m_removeButton, 3, 1, 1, 1);

    spacerItem1 = new QSpacerItem(20, 20, QSizePolicy::Minimum, QSizePolicy::Fixed);

    gridLayout->addItem(spacerItem1, 2, 1, 1, 1);

    m_availableList = new Q3ListView(Frame4);
    m_availableList->addColumn(tr2i18n("Classes Available", 0));
    m_availableList->header()->setClickEnabled(true, m_availableList->header()->count() - 1);
    m_availableList->setObjectName(QString::fromUtf8("m_availableList"));
    QSizePolicy sizePolicy1(static_cast<QSizePolicy::Policy>(7), static_cast<QSizePolicy::Policy>(7));
    sizePolicy1.setHorizontalStretch(1);
    sizePolicy1.setVerticalStretch(0);
    sizePolicy1.setHeightForWidth(m_availableList->sizePolicy().hasHeightForWidth());
    m_availableList->setSizePolicy(sizePolicy1);
    m_availableList->setSelectionMode(Q3ListView::Extended);

    gridLayout->addWidget(m_availableList, 0, 0, 5, 1);

    spacerItem2 = new QSpacerItem(20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding);

    gridLayout->addItem(spacerItem2, 4, 1, 1, 1);


    vboxLayout->addWidget(Frame4);

    CodeGenerationWizardBase->addPage(select, tr2i18n("Select Classes", 0));
    status = new QWidget(CodeGenerationWizardBase);
    status->setObjectName(QString::fromUtf8("status"));
    vboxLayout1 = new QVBoxLayout(status);
    vboxLayout1->setSpacing(10);
    vboxLayout1->setMargin(0);
    vboxLayout1->setObjectName(QString::fromUtf8("vboxLayout1"));
    m_label = new QLabel(status);
    m_label->setObjectName(QString::fromUtf8("m_label"));
    m_label->setWordWrap(false);

    vboxLayout1->addWidget(m_label);

    GroupBox2 = new Q3GroupBox(status);
    GroupBox2->setObjectName(QString::fromUtf8("GroupBox2"));
    GroupBox2->setColumnLayout(0, Qt::Vertical);
    GroupBox2->layout()->setSpacing(10);
    GroupBox2->layout()->setMargin(20);
    vboxLayout2 = new QVBoxLayout(GroupBox2->layout());
    vboxLayout2->setAlignment(Qt::AlignTop);
    vboxLayout2->setObjectName(QString::fromUtf8("vboxLayout2"));
    vboxLayout2->setMargin(20);
    vboxLayout2->setSpacing(10);
    m_statusList = new Q3ListView(GroupBox2);
    m_statusList->addColumn(tr2i18n("Class", 0));
    m_statusList->header()->setClickEnabled(true, m_statusList->header()->count() - 1);
    m_statusList->addColumn(tr2i18n("Generation Status", 0));
    m_statusList->header()->setClickEnabled(true, m_statusList->header()->count() - 1);
    m_statusList->setObjectName(QString::fromUtf8("m_statusList"));

    vboxLayout2->addWidget(m_statusList);


    vboxLayout1->addWidget(GroupBox2);

    CodeGenerationWizardBase->addPage(status, tr2i18n("Code Generation Status", 0));

    retranslateUi(CodeGenerationWizardBase);

    QSize size(396, 386);
    size = size.expandedTo(CodeGenerationWizardBase->minimumSizeHint());
    CodeGenerationWizardBase->resize(size);

    QObject::connect(m_addButton, SIGNAL(clicked()), CodeGenerationWizardBase, SLOT(selectClass()));
    QObject::connect(m_removeButton, SIGNAL(clicked()), CodeGenerationWizardBase, SLOT(deselectClass()));

    QMetaObject::connectSlotsByName(CodeGenerationWizardBase);
    } // setupUi

    void retranslateUi(Q3Wizard *CodeGenerationWizardBase)
    {
    CodeGenerationWizardBase->setWindowTitle(tr2i18n("Code Generation Wizard", 0));
    TextLabel1->setText(tr2i18n("Place all the classes you want to generate code\n"
"for in the right hand side list", 0));
    m_addButton->setText(QString());
    m_addButton->setProperty("toolTip", QVariant(tr2i18n("Add class for code generation", 0)));
    m_selectedList->header()->setLabel(0, tr2i18n("Classes Selected", 0));
    m_removeButton->setText(QString());
    m_removeButton->setProperty("toolTip", QVariant(tr2i18n("Remove class from Code Generation", 0)));
    m_availableList->header()->setLabel(0, tr2i18n("Classes Available", 0));
    CodeGenerationWizardBase->setTitle(select, tr2i18n("Select Classes", 0));
    m_label->setText(tr2i18n("Press the Generation button to start the code generation", 0));
    GroupBox2->setTitle(tr2i18n("Generation Status", 0));
    m_statusList->header()->setLabel(0, tr2i18n("Class", 0));
    m_statusList->header()->setLabel(1, tr2i18n("Generation Status", 0));
    CodeGenerationWizardBase->setTitle(status, tr2i18n("Code Generation Status", 0));
    Q_UNUSED(CodeGenerationWizardBase);
    } // retranslateUi


protected:
    enum IconID
    {
        image0_ID,
        image1_ID,
        unknown_ID
    };
    static QPixmap icon(IconID id)
    {
    static const char* const img0_codegenerationwizardbase[] = { 
"16 15 38 1",
". c None",
"b c #004062",
"# c #00406a",
"e c #00446a",
"a c #08446a",
"J c #185d8b",
"I c #206194",
"H c #296994",
"F c #29699c",
"G c #296d9c",
"D c #31719c",
"E c #3175a4",
"C c #3979a4",
"B c #397da4",
"A c #4181ac",
"y c #4185ac",
"z c #4a89ac",
"x c #528db4",
"v c #5291b4",
"w c #5291bd",
"t c #5a99bd",
"u c #5a9dbd",
"s c #62a5c5",
"r c #6aa5c5",
"o c #6aaec5",
"p c #73aecd",
"q c #7bb6cd",
"l c #7bbacd",
"k c #7bbad5",
"m c #83bad5",
"h c #83c2d5",
"i c #8bc2de",
"f c #94cee6",
"n c #9ccade",
"j c #a4d2e6",
"g c #acdaee",
"d c #acdeee",
"c c #b4deee",
".....#a.........",
"....bcde........",
"....acfca.......",
"....bghide......",
"....ajklmca.....",
"....bnopopde....",
"....aqrsrsrca...",
"....brtututub...",
"....atvvwvvva...",
"....bxyzyzye....",
"....aAABABa.....",
"....bCDEDe......",
"....aFGHa.......",
"....bIJe........",
".....#a........."};


    static const char* const img1_codegenerationwizardbase[] = { 
"16 15 38 1",
". c None",
"e c #004062",
"a c #00406a",
"b c #00446a",
"# c #08446a",
"I c #185d8b",
"J c #206194",
"F c #296994",
"H c #29699c",
"G c #296d9c",
"C c #31719c",
"D c #3175a4",
"E c #3979a4",
"A c #397da4",
"B c #4181ac",
"x c #4185ac",
"y c #4a89ac",
"z c #528db4",
"v c #5291b4",
"w c #5291bd",
"u c #5a99bd",
"t c #5a9dbd",
"r c #62a5c5",
"q c #6aa5c5",
"o c #6aaec5",
"n c #73aecd",
"s c #7bb6cd",
"k c #7bbacd",
"j c #7bbad5",
"l c #83bad5",
"h c #83c2d5",
"g c #8bc2de",
"f c #94cee6",
"p c #9ccade",
"m c #a4d2e6",
"i c #acdaee",
"c c #acdeee",
"d c #b4deee",
"........#a......",
".......bcde.....",
"......#dfd#.....",
".....bcghie.....",
"....#djklm#.....",
"...bcnonnpe.....",
"..#dqrqrqs#.....",
"..etututuqe.....",
"..#vwvvvwu#.....",
"...bxyxyxze.....",
"....#ABABB#.....",
".....bCDCEe.....",
"......#FGH#.....",
".......bIJe.....",
"........#a......"};


    switch (id) {
        case image0_ID: return QPixmap((const char**)img0_codegenerationwizardbase);
        case image1_ID: return QPixmap((const char**)img1_codegenerationwizardbase);
        default: return QPixmap();
    } // switch
    } // icon

};

namespace Ui {
    class CodeGenerationWizardBase: public Ui_CodeGenerationWizardBase {};
} // namespace Ui

class CodeGenerationWizardBase : public Q3Wizard, public Ui::CodeGenerationWizardBase
{
    Q_OBJECT

public:
    CodeGenerationWizardBase(QWidget* parent = 0, const char* name = 0);
    ~CodeGenerationWizardBase();

public slots:
    virtual void selectClass();
    virtual void classGenerated( UMLClassifier * /* c */ );

protected slots:
    virtual void languageChange();

    virtual void deselectClass();


};

#endif // CODEGENERATIONWIZARDBASE_H

